#ifndef __BuddhaBasicEffect_H__
#define __BuddhaBasicEffect_H__

#include "BuddhaGpuEffect.h"
#include "BuddhaColor.h"

namespace BuddhaLib
{
	class BasicEffect : public GpuEffect
	{
	public:
		BasicEffect(GraphicsDevice* device);
		~BasicEffect();
		
		inline void SetWorld(Matrix &mat)
		{
			SetParameter("gWorld", mat);
		}

		inline void SetView(Matrix &mat)
		{
			SetParameter("gView", mat);
		}

		inline void SetProjection (Matrix &mat)
		{
			SetParameter("gProjection", mat);
		}

		inline void SetAmbientLightColor(const Color &color)
		{
			D3DXVECTOR4 vec((FLOAT)color.R / 255, (FLOAT)color.G / 255, (FLOAT)color.B / 255, (FLOAT)color.A / 255);
			SetParameter("Ambient", vec);
		}
	};
}

#endif