#ifndef __BuddhaBoundingBox_H__
#define __BuddhaBoundingBox_H__

#define _BUDDHA_AABB_POSITION_0(b)	((b).Min)
#define _BUDDHA_AABB_POSITION_1(b)	(Vector3((b).Min.X, (b).Max.Y, (b).Min.Z))
#define _BUDDHA_AABB_POSITION_2(b)	(Vector3((b).Max.X, (b).Max.Y, (b).Min.Z))
#define _BUDDHA_AABB_POSITION_3(b)	(Vector3((b).Max.X, (b).Min.Y, (b).Min.Z))

#define _BUDDHA_AABB_POSITION_4(b)	((b).Max)
#define _BUDDHA_AABB_POSITION_5(b)	(Vector3((b).Min.X, (b).Max.Y, (b).Max.Z))
#define _BUDDHA_AABB_POSITION_6(b)	(Vector3((b).Min.X, (b).Min.Y, (b).Max.Z))
#define _BUDDHA_AABB_POSITION_7(b)	(Vector3((b).Max.X, (b).Min.Y, (b).Max.Z))

#include "BuddhaBoundingContainmentType.h"
#include "BuddhaVector3.h"
#include "BuddhaIteratorWrappers.h"

#include <vector>

namespace BuddhaLib
{
	struct BoundingSphere;

	/// Œ苫E{bNX(AABB)킷\
	struct BoundingBox
	{
	public:
		/// Vector3̃Ce[^
		typedef	std::vector<Vector3>	PointList;
		typedef	ConstVectorIterator<PointList>	PointListItr;

		/// AABB̍ŏW
		Vector3 Min;

		/// AABB̍őW
		Vector3 Max;

		/**
		 * @brief RXgN^B{[[̃oEfBO{bNX쐬
		 */
		BoundingBox(void);

		/**
		 * @brief RXgN^BőWƍŏWw肵ăoEfBO{bNX쐬
		 */
		BoundingBox(const Vector3 &min, const Vector3 &max);

		/**
		 * @brief RXgN^B_̏WoEfBO{bNX쐬
		 * @par	vector3Itr	_̃Ce[^ ConstVectorIterator<std::vector<Vector3>>
		 */
		BoundingBox(PointListItr &vector3Itr);

		/**
		 * @brief RXgN^B_̏WoEfBOXtBA쐬
		 * @par	pVectors	Vector3z̐擪AhX
		 * @par	num		z̗vf
		 */
		BoundingBox(Vector3* pVectors, size_t num);

		/**
		 * @brief	E{bNX \e point ܂ł邩ǂ`FbN
		 * @param	sphere	Ώۂ̓_
		 * @param	result	[ʏo] ̋E{bNX \e point ̊֌W߂񋓎q̒l
		 */
		void Contains(const Vector3 &point, CONTAINMENT_TYPE &result) const;

		/**
		 * @brief	E{bNX \e point ܂ł邩ǂ`FbN
		 * @param	sphere	Ώۂ̓_
		 * @return	̋E{bNX \e point ̊֌W߂񋓎q̒l
		 */
		CONTAINMENT_TYPE Contains(const Vector3 &point) const;

		/**
		 * @brief	E{bNX \e sphere ܂ł邩ǂ`FbN
		 * @param	sphere	Ώۂ̋E
		 * @param	result	[ʏo] ̋E{bNX \e sphere ̊֌W߂񋓎q̒l
		 */
		void Contains(const BoundingSphere &sphere, CONTAINMENT_TYPE &result) const;

		/**
		 * @brief	E{bNX \e sphere ܂ł邩ǂ`FbN
		 * @param	sphere	Ώۂ̋E
		 * @return	̋E{bNX \e sphere ̊֌W߂񋓎q̒l
		 */
		CONTAINMENT_TYPE Contains(const BoundingSphere &sphere) const;

		/**
		 * @brief	E{bNX \e box ܂ł邩ǂ`FbN
		 * @param	sphere	Ώۂ̋E{bNX
		 * @param	result	[ʏo] ̋E{bNX \e box ̊֌W߂񋓎q̒l
		 */
		void Contains(const BoundingBox &box, CONTAINMENT_TYPE &result) const;

		/**
		 * @brief	E{bNX \e box ܂ł邩ǂ`FbN
		 * @param	sphere	Ώۂ̋E{bNX
		 * @return	̋E{bNX \e box ̊֌W߂񋓎q̒l
		 */
		CONTAINMENT_TYPE Contains(const BoundingBox &box) const;
	};
}

#endif