#ifndef __BuddhaBounding_H__
#define __BuddhaBounding_H__

#include <d3d9.h>
#include "BuddhaVector3.h"
#include "BuddhaBoundingContainmentType.h"
#include "BuddhaIteratorWrappers.h"

#include <vector>

namespace BuddhaLib
{
	struct BoundingBox;

	/**
	 * @brief oEfBOXtBA\
	 * @todo  BoundingSphere \̂͊Jr̂̂łB
	 */
	struct BoundingSphere
	{
	public:
		/// Vector3̃Ce[^
		typedef	std::vector<Vector3>	PointList;
		typedef	ConstVectorIterator<PointList>	PointListItr;

		/// oEfBOXtBA̒SW
		Vector3 Center;

		/// a
		FLOAT Radius;

		/// RXgN^B傫[̃oEfBOXtBA쐬B
		BoundingSphere();

		/**
		 * @brief RXgN^Bw肳ꂽp[^̃oEfBOXtBA쐬B
		 * @par center SW
		 * @par radius a
		 */
		BoundingSphere(Vector3 center, FLOAT radius);

		/**
		 * @brief RXgN^B_̏WoEfBOXtBA쐬
		 * @par	vector3Itr	_̃Ce[^ ConstVectorIterator<std::vector<Vector3>>
		 * @remarks
		 *     AABBɑ΂XtBAƂČvZ
		 */
		BoundingSphere(PointListItr &vector3Itr);

		/**
		 * @brief RXgN^B_̏WoEfBOXtBA쐬
		 * @par	pVectors	Vector3z̐擪AhX
		 * @par	num		z̗vf
		 * @remarks
		 *     AABBɑ΂XtBAƂČvZ
		 */
		BoundingSphere(Vector3* pVectors, size_t num);

		/// rZq == ̃I[o[[h
		inline bool operator == (const BoundingSphere& b)
		{
			return (Center == b.Center && Radius == b.Radius);
		}

		/// rZq != ̃I[o[[h
		inline bool operator != (const BoundingSphere& b)
		{
			return (Center != b.Center || Radius != b.Radius);
		}

		/// Q̃XtBAĂ邩ǂl擾B
		inline bool Intersects(const BoundingSphere &sphere) const;

		/**
		 * @brief	E \e point ܂ł邩ǂ`FbN
		 * @param	point	Ώۂ̓_
		 * @param	result	[ʏo] ̋E \e point ̊֌W߂񋓎q̒l
		 */
		void Contains(const Vector3 &point, CONTAINMENT_TYPE &result) const;

		/**
		 * @brief	E \e point ܂ł邩ǂ`FbN
		 * @param	point	Ώۂ̓_
		 * @return	̋E \e point ̊֌W߂񋓎q̒l
		 */
		CONTAINMENT_TYPE Contains(const Vector3 &point) const;

		/**
		 * @brief	E \e sphere ܂ł邩ǂ`FbN
		 * @param	sphere	Ώۂ̋E
		 * @param	result	[ʏo] ̋E \e sphere ̊֌W߂񋓎q̒l
		 */
		void Contains(const BoundingSphere &sphere, CONTAINMENT_TYPE &result) const;

		/**
		 * @brief	E \e sphere ܂ł邩ǂ`FbN
		 * @param	sphere	Ώۂ̋E
		 * @return	̋E \e sphere ̊֌W߂񋓎q̒l
		 */
		CONTAINMENT_TYPE Contains(const BoundingSphere &sphere) const;

		/**
		 * @brief	E \e box ܂ł邩ǂ`FbN
		 * @param	box		Ώۂ̋E{bNX
		 * @param	result	[ʏo] ̋E \e box ̊֌W߂񋓎q̒l
		 */
		void Contains(const BoundingBox &box, CONTAINMENT_TYPE &result) const;

		/**
		 * @brief	E \e box ܂ł邩ǂ`FbN
		 * @param	box		Ώۂ̋E{bNX
		 * @return	̋E \e box ̊֌W߂񋓎q̒l
		 */
		CONTAINMENT_TYPE Contains(const BoundingBox &box) const;
	};
}

#endif