#ifndef __BuddhaColor_H__
#define __BuddhaColor_H__

#include <d3dx9.h>

#include "BuddhaLibPrerequisites.h"
#include "BuddhaVector3.h"
#include "BuddhaVector4.h"

namespace BuddhaLib
{
	/// D3DCOLOR Ɠl̃J[l
	typedef DWORD PackedColor;

	/// F
	struct Color
	{
	public:
		BYTE A;
		BYTE R;
		BYTE G;
		BYTE B;

		/// RXgN^
		Color(void);

		/// RXgN^
		Color(BYTE r, BYTE g, BYTE b, BYTE a = 255);

		/// RXgN^
		Color(const Vector3 &vector);

		Color(const Vector4 &vector);

		inline PackedColor _getPackedColor(void) const
		{
			return D3DCOLOR_ARGB(A, R, G, B);
		}

		static D3DXCOLOR CreateD3DXColor(const Color &color);

		static const Color White;
		static const Color Black;
		static const Color CornflowerBlue;
	};
}


#endif