#ifndef __BuddhaDummy_H__
#define __BuddhaDummy_H__

/**
 * \mainpage Cy[W
 * \section introduction Cg_NV
 * BuddhaLib / BuddhaCpp  API hLgւ悤B
 * ̃hLg͂܂łA BuddhaLib găAvP[VJۂɎQƂł
 * NXƃ\bh̎dlɊւ鑽̏񂪂܂B
 * 
 * BuddhaLib ͎g₷A܂ XNA ƗގNX̌nƂŊwKRXg/XN}RcCu
 * ڎwĂ܂B̃hLgɊւāAĂ܂A minahito@users.sourceforge.jp ܂
 * AB
 *
 * \section index CfbNX
 * \li <a class="el" href="./namespaces.html">l[Xy[X</a> : OԂŕꂽCuꂼꂽǂꍇ͂
 * \li <a class="el" href="./annotated.html">NXXg</a> : T}t̑SNXꗗ
 * \li <a class="el" href="./functions.html">oXg</a> : API ̋@\ȂƂɂT܂
 * \li \ref how_to_dev_application : vWFNg̒ǉ@Yꂽ炱ŒׂĂ
 *
 * \subsection subindex tL
 * \li \ref conventions
 * \li \ref sharedptr_page
 * \li \ref example_header
 *
 * \section example Tv
 * \code
 * #include <BuddhaLib.h>
 * using namespace BuddhaLib;
 *
 * // }Ng WinMain ֐Ƃ邱Ƃł܂
 * #include <example/BuddhaExampleMain.h>
 *
 * class MyGame : public Game
 * {
 * protected:
 *    // KЂƂ̃OtBbNfoCX}l[WKvł
 *    GraphicsDeviceManager *m_pGraphics;
 * 
 * public:
 *    MyGame(void)
 *    {
 *      // RXgN^ŁAOtBNXfoCX}l[WĂĂ
 *      m_pGraphics = new GraphicsDeviceManager(this);
 *    }
 *
 *    virtual ~MyGame(void)
 *    {
 *      // SAFE_DELETE }N NULL łȂ|C^ delete ANULL ɏ}Nł
 *      SAFE_DELETE(m_pGraphics);
 *    }
 *
 * protected:
 *    void Initialize(void)
 *    {
 *      // ɃOtBbNȊȌR[h܂
 *    }
 *
 *    void LoadGraphicsContents(bool loadAllContent)
 *    {
 *      // ɃOtBbN֌W̃[hsR[h܂
 *    }
 *
 *    void UnloadGraphicsContents(bool loadAllContent)
 *    {
 *      // ɃOtBbN֌W̔jsR[h܂
 *    }
 *
 * public:
 *    void Update(const GameTime &gameTime)
 *    {
 *      // ɃQ[WbN܂
 *    }
 *
 *    void Draw(const GameTime &gameTime)
 *    {
 *      m_pGraphics->GetGraphicsDevice()->Clear(Color::CornflowerBlue);
 *      // ɃQ[`惍WbN܂
 *    }
 * }
 * \endcode
 *
 * \page conventions RxV
 * 
 * \section section1 struct  class
 * BuddhaLib  XNA Framework Ɠl̑슴J҂ɗ^邱ƂړIɊJĂ邽߁A
 * \̂ƃNX̎g C# ̌gpɉ̂ƂȂĂ܂Bm̂ƂAC++
 * ̓NXƍ\̂ɂ͕WANZXxȊÖႢ͂܂B
 *
 * A BuddhaLib ł́A{I new Iy[^gpɒlmۂAQƂRs[n
 * \Ȃ̂ structAȊÔ̂ class Œ`sĂ܂B
 *
 * struct ͌IɃpubNoϐĂAڒl̓ǂݏ\łBtɁA
 * class ͌IɃoϐւ̃ANZX͂ł܂B
 *
 *
 * \section section2 STLRei̗pAPIK
 * STL Reigpꍇ͕K typedef B
 * ^łĂɉĊeNX typedef B typedef ̖K͈ȉɏB
 * 
 *
 * \subsection section2s1 vector  list
 * {i[NX} + {List}
 *  \code
 *  typedef std::vector<Model> ModelList;
 *  ModelList mModelList;
 *  \endcode
 * 
 * \subsection section2s2 map
 * {i[NX} + {Map}
 *  \code
 *  typedef std::vector<String, Model> ModelMap;
 *  ModelMap mModelMap;
 *  \endcode
 *
 * \section section3 NXõReiւ̃ANZX
 * friend NXȊÕNXANX̃ołSTLReiɒڃANZXĂ͂ȂȂB
 * KANZXo֐ʂĒl̂sƁB
 *
 * ACe[^[nKvꍇ́Awb_Ő錾ĂCe[^[̃bp[gpāA
 * STL ReĩCe[^[𒼐ڎgpȂčςނ悤ɂB
 *
 * \subsection section3s2 APǏn
 *   \li list, vector Rei̗vf^擾郁o֐ GetNum + {NXinj}
 *   \li Y^ăRei̒g擾郁o֐ Get + {NXiPnj}
 *   \li YуTCY unsigned intBXgbvR[hAG[KvP[X͂قƂ
 *       ǂȂƎv̂ signed int ł͂ȂA UINT_MAX gpB
 */

/**
 * \page how_to_dev_application AvP[V̊J@

    \section required_for_develop JɕKvȂ
	    \li VisualStudio C++ 
		\li Microsoft DirectX9 SDK Feb 2007
		
		DirectX9 SDK ̓CXg[ApXɒʂĂ܂B

    \section add_project vWFNg̍쐬
		\li \[VGNXv[uǉvuVvWFNgvIт܂B
		\li C++ ̃ev[guWin32AvP[VvIŁAvWFNg͂܂B
		\li Win32AvP[VEBU[hũvWFNg(E)vI܂B

		̃vWFNg쐬\[VGNXv[ɕ\܂B
		vpeBŃrhݒ肵Ă܂At@C܂ȂԂł C++ ֌W
		ݒ肪ł܂BŁA܂ main() ֐i=WinMainjLqt@Cǉ܂B

		t@CǉAvpeBJĊݒ肵Ă܂BAvP[V쐬
		iK Debug  Release ̂Q̍\Ă܂AuׂĂ̍\vIԂƋʂ̐ݒ
		ōsƂł̂ŕ֗łB

		\li u\vpeBvuSʁv́uZbgvuUnicodeZbggpvɂȂ
			邱ƂmF
		\li C++ uǉ̃CXg[fBNgvɃCXg[ BuddhaLib  include fBN
		    gw肵܂B
		\li uJvúvɈȉ̃Cuǉ܂
		    - BuddhaLib.lib
			- d3dxof.lib dxguid.lib d3dx9d.lib d3d9.lib winmm.lib dinput8.lib

		Ƃ͍D݂ɂ킹ĐݒĂ܂B

		\li \vpeBS
		   - o̓fBNg bin\\$(ConfigurationName)
		   - ԃfBNg obj\\$(ConfigurationName)

   \note
		JJn܂傤B
		葁AvP[VJ邽߂ \ref example_main g@܂B
 */


#endif