#ifndef __BuddhaEffect_H__
#define __BuddhaEffect_H__

#include <d3dx9.h>
#include "BuddhaColor.h"
#include "BuddhaVector3.h"
#include "BuddhaVector4.h"
#include "BuddhaSharedPtr.h"

#include <vector>

namespace BuddhaLib
{
	class GraphicsDevice;
	class EffectTechnique;
	class EffectPass;
	struct Matrix;
	class BasicEffect;
	class Texture2D;
	class GpuEffect;

	/**
	 * @internal
	 */
	typedef D3DXHANDLE _BuddhaHandle;

	/// vO}uVF[_ɑ΂p[^̓͂AeNjbNI邱ƂłC^[tFCX
	class Effect
	{
		friend EffectPass;
		friend EffectTechnique;
		friend GpuEffect;

	public:
		typedef std::vector<EffectTechnique*> TechniqueList;

	protected:
		/**
		 * @brief eNjbÑXg
		 * @todo ̃NXSȃC^[tFCXɂ邽߂ɂ́Aɂ͕sv
		 */
		TechniqueList mTechniqueList;

		/**
		 * @brief ݂̃eNjbNւ̃|C^
		 * @todo ̃NXSȃC^[tFCXɂ邽߂ɂ́Aɂ͕sv
		 */
		EffectTechnique* m_pCurrentTechnique;

		Effect();

		/**
		 * @brief GtFNg Begin() Ăяo End() ܂Ă΂ĂȂԂtO
		 * @todo ̃NXSȃC^[tFCXɂ邽߂ɂ́Aɂ͕sv
		 */
		bool mIsBegan;

	public:
		virtual ~Effect();

		/// GtFNg̎eNjbN̐擾
		virtual int GetNumTechniques(void) const;

		/**
		 * @brief ݑI𒆂̃eNjbN擾
		 * @see SetCurrentTechnique()
		 */
		virtual EffectTechnique* GetCurrentTechnique() const;

		/// JgeNjbNI
		virtual void SetCurrentTechnique(LPCSTR name) = NULL;

		/// JgeNjbNI
		virtual void SetCurrentTechnique(String &name) = NULL;

		/// JgeNjbNI
		virtual void _setCurrentTechnique(_BuddhaHandle handle) = NULL;

		/// GtFNgJn
		virtual void Begin(void) = NULL;

		/// GtFNgJn
		virtual void End(void) = NULL;

		/// }gNXw肵p[^ɃZbg
		virtual void SetParameter(LPCSTR handle, const Matrix &mat) = NULL;

		/// }gNX̔zw肵p[^ɃZbg
		virtual void SetParameter(LPCSTR handle, const Matrix*, unsigned int count) = NULL;

		/**
		 * D3DXVECTOR4 p[^ɃZbg
		 * @internal
		 * @todo ̃C^[tFCXɂ͕sv
		 */
		virtual void SetParameter(LPCSTR handle, const D3DXVECTOR4 &vec) = NULL;

		/// Vector3 ̒lw肵p[^ɃZbg
		virtual void SetParameter(LPCSTR handle, const Vector3 &vec) = NULL;

		/// Vector4 ̒lw肵p[^ɃZbg
		virtual void SetParameter(LPCSTR handle, const Vector4 &vec) = NULL;

		/// eNX`w肵p[^ɃZbg
		virtual void SetParameter(LPCSTR handle, const Texture2D* tex) = NULL;

		/// float lw肵p[^ɃZbg
		virtual void SetParameter(LPCSTR handle, const float value) = NULL;

		virtual _BuddhaHandle _getParameterByHandle(LPCSTR name) = NULL;

		virtual _BuddhaHandle _getTechniqueByName(LPCSTR name) = NULL;

		/// F̒lw肵p[^ɃZbg
		virtual void SetParameter(LPCSTR handle, const Color &color) = NULL;

		/// GtFNgJnȍ~ɏ񂾃p[^VF[_ɑ
		virtual void _commit(void) = NULL;

		/// ̃GtFNgpXvO}uVF[_ł邩ǂ擾
		virtual bool _isGpuEffect(void) const = NULL;
	};

	/// GtFNgNXp̔틤L|C^
	class EffectPtr : public SharedPtr<Effect>
	{
	public:
		EffectPtr() : SharedPtr<Effect>() {}
		explicit EffectPtr(Effect* rep) : SharedPtr<Effect>(rep) {}
		EffectPtr(const EffectPtr &r) : SharedPtr<Effect>(r) {}
	protected:
		void destory(void)
		{
			SharedPtr<Effect>::destroy();
		}
	};
}

#endif