#ifndef __BuddhaGameTime_H__
#define __BuddhaGameTime_H__

#include "BuddhaLibPrerequisites.h"

namespace BuddhaLib
{
	class Game;

	/// ԊԊuiQ̎̍j\\
	struct TimeSpan
	{
	private:
		/// v~b
		double mTotalMilliseconds;
		double mTotalSeconds;

		/// Pʂ̎ԊԊu
		double mTotalMinutes;

		double mTotalHours;
		double mTotalDays;

		mutable int mHours;
		mutable bool mOutOfDateHours;

		mutable int mMinutes;
		mutable bool mOutOfDateMinutes;

		mutable int mSeconds;
		mutable bool mOutOfDateSeconds;

		mutable int mMilliseconds;
		mutable bool mOutOfDateMilliseconds;

	public:
		TimeSpan(void);

		/**
		 * @brief V TimeSpan w肵~b̐ɏ
		 */
		TimeSpan(DWORD msec);

		/**
		 * @brief ԊԊuPʂŎ擾B
		 * @remarks
		 *     ) 25.5͂QTƂPQԂ\
		 */
		double GetTotalDays(void) const
		{
			return mTotalDays;
		}

		/**
		 * @brief ԊԊuԒPʂŎ擾B
		 * @remarks
		 *     ) 25.5͂PƂPԂRO\
		 */
		double GetTotalHours(void) const
		{
			return mTotalHours;
		}

		/**
		 * @brief ԊԊu𕪒PʂŎ擾B
		 * @remarks
		 *     ) 123.5͂QԂRROb\
		 */
		double GetTotalMinutes(void) const
		{
			return mTotalMinutes;
		}

		/**
		 * @brief ԊԊubPʂŎ擾
		 * @remarks
		 *     ) 123.5͂QR.Tb\
		 *     
		 */
		double GetTotalSeconds(void) const
		{
			return mTotalSeconds;
		}

		/**
		 * @brief ԊԊu~bPʂŎ擾
		 * @remarks
		 *     12300  12.3 b\
		 */
		double GetTotalMilliseconds(void) const
		{
			return mTotalMilliseconds;
		}

		/**
		 * @brief ݂ TimeSpan \̂\[ȂŎ擾܂B 
		 * @todo LbVɏĈ
		 */
		int GetDays(void) const
		{
			return (int)(GetTotalDays());
		}

		/**
		 * @brief ݂ TimeSpan \̂\Ԑ[ȂŎ擾܂B
		 */
		int GetHours(void) const
		{
			if (!mOutOfDateHours)
			{
				mHours = (int)(mTotalHours - (int)GetTotalDays() * 24);
			}

			return mHours;
		}

		/**
		 * @brief ݂ TimeSpan \̂\[ȂŎ擾܂B
		 */
		int GetMinutes(void) const
		{
			if (mOutOfDateMinutes)
			{
				mMinutes = (int)(mTotalMinutes - (int)GetTotalHours() * 60);
			}

			return mMinutes;
		}

		/**
		 * @brief ݂ TimeSpan \̂\Ԑ[ȂŎ擾܂B
		 */
		int GetSeconds(void) const
		{
			if (mOutOfDateSeconds)
			{
				mSeconds = (int)(mTotalSeconds - (int)GetTotalMinutes() * 60);
			}

			return mSeconds;
		}

		/**
		 * @brief ݂ TimeSpan \̂\Ԑ[ȂŎ擾
		 * @remarks
		 *     ԊԊu̕b̒[̒l𐮐lŕԂ
		 * @todo LbVɏĈ
		 */
		int GetMilliseconds(void) const
		{
			if (mOutOfDateMilliseconds)
			{
				mMilliseconds = (int)(mTotalMilliseconds - (int)GetTotalMilliseconds() * 1000);
			}

			return mMilliseconds;
		}
		//------------------------------------------------------------------------
		inline TimeSpan operator + (const TimeSpan& value)
		{
			return TimeSpan((DWORD)(mTotalMilliseconds + value.mTotalMilliseconds));
		}
		//------------------------------------------------------------------------
		inline TimeSpan operator += (const TimeSpan &value)
		{
			mTotalMilliseconds += value.mTotalMilliseconds;
			mTotalSeconds = mTotalMilliseconds / 1000.0f;
			mTotalMinutes = mTotalSeconds / 60.0f;
			mTotalHours = mTotalMinutes / 60.0f;
			mTotalDays = mTotalHours / 24.0f;

			return *this;
		}
	};

	/**
	 * @brief Q[킷\
	 * 
	 * ̍\̂ TimeSpan \̂𗘗pāAQ[NẴ^CXpiԊԊu̗ʁjƁA
	 * Õt[̃^CXp񋟂B
	 * BuddhaLib::Game ͌Œt[̂Ă邽߁A Game::Update() PbԂɂROĂяo
	 * Ɗ҂邱ƂłB̊ҒlQ[Ԃ̒lłA ElapsedGameTime  TotalGameTime
	 * Œ񋟂ĂB
	 *
	 * ʏ ElapsedGameTime == ElapsedRealTime łATotalGameTime == TotalRealTime łB
	 * 
	 * Aɂ́AA Game::Draw() XLbv Game::Update() ĂяoȂ
	 * ΂ȂȂ󋵂ꍇB̂悤ȃP[Xł́A ElapsedGameTime  TotalGameTime
	 * ɂ̓o[`Ȓl߂邱ƂłA ElapsedRealTime  TotalRealTime uv̒l񋟂B
	 * ̂悤ɁAAԂƃQ[ԂɈႢƁA IsRunningSlowly() ͐^Ԃ悤ɂȂB
	 */
	struct GameTime
	{
		friend Game;

	private:
		bool mIsRunningSlowly;

	public:
		/**
		 * @brief Q[X^[gĂ̎ԁiǎvǰoߎԊԊu
		 */
		TimeSpan TotalRealTime;

		/**
		 * @brief Ō̃t[̎ԁiǎvǰoߎԊԊu
		 */
		TimeSpan ElapsedRealTime;

		/**
		 * @brief Q[X^[gĂ̌oߎԊԊu
		 */
		TimeSpan TotalGameTime;

		/**
		 * @brief Ō̃t[̌oߎԊԊu
		 */
		TimeSpan ElapsedGameTime;

		/// RXgN^
		GameTime(void)
			: mIsRunningSlowly(false)
		{
		}

		/// RXgN^
		GameTime(TimeSpan &totalRealTime, TimeSpan &elapsedRealTime, TimeSpan &totalGameTime, TimeSpan &elapsedGameTime)
			: TotalRealTime(totalRealTime),
			  ElapsedRealTime(elapsedRealTime),
			  TotalGameTime(totalGameTime),
			  ElapsedGameTime(elapsedGameTime),
			  mIsRunningSlowly(false)
		{
		}

		/// RXgN^
		GameTime(TimeSpan &totalRealTime, TimeSpan &elapsedRealTime,
			TimeSpan &totalGameTime, TimeSpan &elapsedGameTime, bool isRunningSlowly)
			: TotalRealTime(totalRealTime),
			  ElapsedRealTime(elapsedRealTime),
			  TotalGameTime(totalGameTime),
			  ElapsedGameTime(elapsedGameTime),
			  mIsRunningSlowly(isRunningSlowly)
		{
		}

		/**
		 * @brief Q[[v TargetElapsedTime 莞ԂĂ邩ǂl擾
		 * @return l^̏ꍇA鏈Ă
		 *
		 * l^̏ꍇAQ[[v͏ԂɂƍlBɒǂt߂ɉ
		 * Ȃ΂ȂȂB
		 */
		bool IsRunningSlowly()
		{
			return mIsRunningSlowly;
		}
	};
}

#endif