#ifndef __BuddhaGpuEffect_H__
#define __BuddhaGpuEffect_H__

#include "BuddhaEffect.h"
#include <map>

namespace BuddhaLib
{
	class GraphicsDevice;
	class GpuEffectTechnique;
	class GpuEffectPass;

	/// vO}uVF[_p̃GtFNg
	class GpuEffect : public Effect
	{
		friend GpuEffectTechnique;
		friend GpuEffectPass;

	public:
		/**
		 * @brief eNjbNƃeNjbNւ̃|C^̃}bv
		 * @remarks
		 *     GetCureentTechnique() ĂяoAeNjbNƂɂ̓e
		 *     LbVĂ߂̃nbV}bv
		 */
		typedef std::map<String, EffectTechnique*> TechniqueMap;

	protected:
		GpuEffect(GraphicsDevice* device);

		/// DirectX9 GtFNgւ̃|C^
		LPD3DXEFFECT m_pEffect;

		/**
		 * @brief DirectX9 eNjbÑLbV
		 */
		TechniqueMap mTechniqueMap;

		/**
		 * @brief foCXւ̃|C^
		 * @attention
		 *      fXgN^ȂǂŉĂ͂ȂȂB
		 */
		GraphicsDevice* m_pDevice;

	public:
		~GpuEffect();

		/**
		 * filepath vO}uVF[_[hA out ɓn
		 * @remarks
		 *     VFA[hE|C^Ŏ󂯎肽ȂꍇɎgpB
		 */
		static void FromFile(GraphicsDevice* device, LPCWSTR filePath, GpuEffect** out);

		/// filepath vO}uVF[_[hĕԂ
		static EffectPtr FromFile(GraphicsDevice* device, LPCWSTR filePath);

		void SetCurrentTechnique(LPCSTR name);
		void SetCurrentTechnique(String &name);
		void _setCurrentTechnique(_BuddhaHandle handle);

		void Begin();
		void End();

		void SetParameter(LPCSTR handle, const Matrix &mat);
		void SetParameter(LPCSTR handle, const Matrix*, unsigned int count);

		void SetParameter(LPCSTR handle, const D3DXVECTOR4 &vec);
		void SetParameter(LPCSTR handle, const Vector3 &vec);
		void SetParameter(LPCSTR handle, const Vector4 &vec);
		void SetParameter(LPCSTR handle, const Texture2D* tex);
		void SetParameter(LPCSTR handle, const float value);

		_BuddhaHandle _getParameterByHandle(LPCSTR name);

		_BuddhaHandle _getTechniqueByName(LPCSTR name);

		inline void SetParameter(LPCSTR handle, const Color &color);

		void _commit(void);

		inline bool _isGpuEffect(void) const;

	protected:
		void setCurrentTechnique(EffectTechnique *technique);
	};
}

#endif