#ifndef __BuddhaGraphicsDeviceManager_H__
#define __BuddhaGraphicsDeviceManager_H__

#include "BuddhaGraphicsDevice.h"
#include "BuddhaLibPrerequisites.h"

#include <d3d9.h>

#define BUDDHA_GRAPHICSDEVICEMANAGER_SERVICENAME	L"GraphicsDeviceManager"

namespace BuddhaLib
{
	/// OtBbNfoCX}l[W
	class GraphicsDeviceManager
	{
	private:
		Game* m_pGame;

	protected:
		GraphicsDevice *m_pDevice;

		/// obNobt@̕
		int mPreferredBackBufferWidth;

		/// obNobt@̍
		int mPreferredBackBufferHeight;

		/// foCXtXN[[hŊJnׂǂl
		bool mIsFullScreen; 

	public:
		/// u
		static D3DPRESENT_PARAMETERS _d3dpp;

		/// RXgN^BQ[NX̂݌ĂяoׂłB
		GraphicsDeviceManager(Game *game);
		virtual ~GraphicsDeviceManager();

		GraphicsDevice* GetGraphicsDevice(void)
		{
			return m_pDevice;
		}

		virtual void CreateDevice(void);

		/**
		 * @brief obNobt@̕ݒ
		 * @exception ArgumentOutOfRangeException Oȏł͂ȂƂ
		 */
		void SetPreferredBackBufferWidth(int width)
		{
			if (width < 0)
				throw new ArgumentOutOfRangeException();

			mPreferredBackBufferWidth = width;
		}

		/// obNobt@̕擾
		int GetPreferredBackBufferWidth(void)
		{
			return mPreferredBackBufferWidth;
		}

		/**
		 * @brief obNobt@̍ݒ
		 * @exception ArgumentOutOfRangeException Oȏł͂ȂƂ
		 */
		void SetPreferredBackBufferHeight(int height)
		{
			mPreferredBackBufferHeight = height;
		}

		/// obNobt@̍擾
		int GetPreferredBackBufferHeight(void)
		{
			return mPreferredBackBufferHeight;
		}

		/// foCXtXN[[hŊJnׂǂlݒ肷
		void SetIsFullScreen(bool isFullScreen)
		{
			mIsFullScreen = isFullScreen;
		}

		/// foCXtXN[[hŊJnׂǂl擾
		bool GetIsFullScreen(void) const
		{
			return mIsFullScreen;
		}

		/// t[̕`Jn
		virtual bool BeginDraw(void)
		{
			return SUCCEEDED(m_pDevice->_getD3D9Device()->BeginScene());
		}

		/// Q[̕`̍ŌɌĂяoAPresent s
		virtual bool EndDraw(void)
		{
			m_pDevice->_getD3D9Device()->EndScene();

			m_pDevice->Present();

			return true;
		}
	};
}

#endif