#ifndef __BuddhaHardwareEffectLight_H__
#define __BuddhaHardwareEffectLight_H__

#include "BuddhaLibPrerequisites.h"
#include "BuddhaColor.h"
#include "BuddhaVector3.h"

#include <d3d9.h>

namespace BuddhaLib
{
	/**
	 * @brief n[hEFAGtFNgŎgp郉Cg̃C^[tFCX
	 * @remarks
	 *     n[hEFAGtFNggpĂvOAAvO}uVF[_
	 *     ۂɁAR[hύXʂȂčςނ悤ɒ`ĂC^[tFCX
	 */
	class IHardwareDirectionalLight
	{
	public:
		/**
		 * @brief fBt[YFݒ肷
		 */
		virtual void SetDiffuseColor(const Color &color) = NULL;

		/**
		 * @brief XyL[Fݒ肷
		 */
		virtual void SetSpecularColor(const Color &color) = NULL;

		/**
		 * @brief Cg̏Ǝ˕ݒ肷
		 */
		virtual void SetDirection(const Vector3 &direction) = NULL;

		/**
		 * @brief Cg̗L/ݒ肷
		 * @param bEnabled Cg̗L/Ăl
		 */
		virtual void SetEnabled(bool bEnabled) = NULL;
	};

	class HardwareEffectPass;

	/// HardwareEffect p IHardwareDirectionalLight CgNX
	class HardwareDirectionalLight : public IHardwareDirectionalLight
	{
		friend HardwareEffectPass;

	protected:
		/// Direct3D Light \
		D3DLIGHT9 mD3D9Light;

		/// ̃Cg̗L/tO
		bool mEnabled;

	public:
		/**
		 * @internal
		 * @brief RXgN^
		 */
		HardwareDirectionalLight()
			: mEnabled(false)
		{
			mD3D9Light.Type = D3DLIGHT_DIRECTIONAL;
		}

		/**
		 * @internal
		 * @brief fXgN^
		 */
		virtual ~HardwareDirectionalLight()
		{
		}

		void SetDiffuseColor(const Color &color)
		{
			mD3D9Light.Diffuse = Color::CreateD3DXColor(color);
		}

		void SetSpecularColor(const Color &color)
		{
			mD3D9Light.Specular = Color::CreateD3DXColor(color);
		}

		void SetDirection(const Vector3 &direction)
		{
			Vector3::CreateD3DVECTOR(direction, mD3D9Light.Direction);
		}

		void SetEnabled(bool bEnabled)
		{
			mEnabled = bEnabled;
		}
	};
}

#endif