#ifndef __BuddhaInput_H__
#define __BuddhaInput_H__

#include <d3dx9.h>
#include <dinput.h>

#define KEY_NUM	256

namespace BuddhaLib
{
	class Keyboard;
	class Game;

	/// L[{[h͑uɂċL^ꂽL[Xg[N̏Ԃ\܂B
	struct KeyboardState
	{
	friend Keyboard;

	private:
		BYTE mKeys[KEY_NUM];

	public:
		KeyboardState();

		/**
		 * @brief w肳ꂽL[Ԃɂ邩ǂ𒲂ׂ
		 * @param key L[ԍB DIK_ 萔ANX Keys ̒lwł܂B
		 */
		bool IsKeyDown(int key);

		/**
		 * @brief w肳ꂽL[Ԃɂ邩ǂ𒲂ׂ
		 * @param key L[ԍB DIK_ 萔ANX Keys ̒lwł܂B
		 */
		bool IsKeyUp(int key);
	};

	/**
	 * @brief L[{[h̓foCXL[Xg[Ň܂
	 * @attention
	 *     L[{[h̓foCX擾L[Xg[NԂ́At[ɍXV܂A GetState()
	 *     ł͍XV܂BfoCX̏AXVAVbg_Eij͓ŕĂA Game NX
	 *     玩IɃRg[܂B
	 */
	class Keyboard
	{
		friend Game;

	private:
		static LPDIRECTINPUTDEVICE8 m_pInputDevice;
		static KeyboardState _mState;

		Keyboard(void){}
		~Keyboard(void){}

		/**
		 * @internal
		 * @brief m_pInputDevice ̏s
		 * @return Ɏsꍇ false Ԃ
		 * @remarks
		 *     ̓foCX̊mێiɂẮAmۂɎsꍇB
		 *     Ẵ\bh͏ɎsĂOX[ȂB
		 */
		static bool _initialize(void);

		static void _shutdown(void);

		/**
		 * @internal
		 * @brief ŐṼL[Xg[NfoCX擾B
		 * @remarks
		 *      ̃o֐ Game NXɂăt[ɌĂяo܂B
		 */
		static void _update(void);

		/**
		 * @brief obNOEhp̍XV
		 * @attention
		 *     Game NX݂̂̃\bhR[
		 */
		static void _disupdate(void);

		/**
		 * @internal
		 * @brief foCX̍Ď擾
		 * @remarks
		 *      ̃o֐ Game NXɂăAvP[VANeBuɂȂۂɌĂяo܂B
		 */
		static void _acquire(void);

	public:
		/**
		 * @brief ݂̃L[Xe[g擾
		 */
		static KeyboardState GetState(void);
	};

	/**
	 * @brief L[ԍ񋓂ĂNX
	 * @remarks
	 *     ̃NX́A C# X^C enum lw񋟂邽߂ɑ݂ĂAXNA o҂ C++ ł
	 *     l̃X^CŃL[ԍw肷邱ƂłB
	 * @todo ׂĂ DIK L[ԍԗĂȂ
	 */
	class Keys
	{
	public:
		static const int A		= DIK_A;			//< A Key
		static const int B		= DIK_B;			//< B Key
		static const int Back	= DIK_BACK;			//< B Key
		static const int C		= DIK_C;			//< C Key
		static const int D		= DIK_D;			//< D Key
		static const int Down   = DIK_DOWN;			//< DOWN ARROW key
		static const int E		= DIK_E;			//< E Key
		static const int F		= DIK_F;			//< F Key
		static const int G		= DIK_G;			//< G Key
		static const int H		= DIK_H;			//< H Key
		static const int I		= DIK_I;			//< I Key
		static const int K		= DIK_K;			//< K Key
		static const int L		= DIK_L;			//< L Key
		static const int Left	= DIK_LEFT;			//< LEFT ARROW key
		static const int LeftAlt = DIK_LALT;		//< LEFT ALT key
		static const int LeftShift = DIK_LSHIFT;	//< LEFT SHIFT key
		static const int M		= DIK_M;			//< M Key
		static const int N		= DIK_N;			//< N Key
		static const int NumPad0 = DIK_NUMPAD0;
		static const int NumPad1 = DIK_NUMPAD1;
		static const int NumPad2 = DIK_NUMPAD2;
		static const int NumPad3 = DIK_NUMPAD3;
		static const int NumPad4 = DIK_NUMPAD4;
		static const int NumPad5 = DIK_NUMPAD5;
		static const int NumPad6 = DIK_NUMPAD6;
		static const int NumPad7 = DIK_NUMPAD7;
		static const int NumPad8 = DIK_NUMPAD8;
		static const int NumPad9 = DIK_NUMPAD9;
		static const int O		= DIK_O;			//< O Key
		static const int P		= DIK_P;			//< P Key
		static const int Q		= DIK_Q;			//< Q Key
		static const int R		= DIK_R;			//< R Key
		static const int Right	= DIK_RIGHT;		//< Right Key
		static const int S		= DIK_S;			//< S Key
		static const int Space	= DIK_SPACE;		//< Space Key
		static const int T		= DIK_T;			//< T Key
		static const int U		= DIK_U;			//< U Key
		static const int Up     = DIK_UP;			//< UP ARROW key
		static const int V		= DIK_V;			//< V Key
		static const int W		= DIK_W;			//< W Key
		static const int X		= DIK_X;			//< X Key
		static const int Y		= DIK_Y;			//< Y Key
		static const int Z		= DIK_Z;			//< Z Key
	};
}

#endif