#ifndef __BuddhaMath_H__
#define __BuddhaMath_H__

#include "BuddhaLibPrerequisites.h"
#include "BuddhaQuaternion.h"

#include <math.h>
#include <limits>

namespace BuddhaLib
{
	struct Vector3;

	/// wp̐ÓI֐W߂NX
	class Math
	{
	public:

		/**
		 * @brief w肳ꂽl̕Ԃ܂
		 */
		static inline Real Sqrt(Real d)
		{
			return sqrt(d);
		}

		static inline Real Sin(Real d)
		{
			return sin(d);
		}

		static inline Real Cos(Real d)
		{
			return cos(d);
		}

		static bool RealEqual(Real a, Real b, Real tolerance = std::numeric_limits<Real>::epsilon());
	};

	/// ĽvZs߂̃wp֐W
	class MathHelper
	{
	public:
		static const Real Pi;
		static const Real TwoPi;

		/**
		 * @brief xWAϊ
		 */
		static inline Real ToRadians(Real degree)
		{
			return (Pi / 180) * degree;
		}

		static inline Real ToRadians(FLOAT degree)
		{
			return (Pi / 180) * degree;
		}

		static inline Real ToDegree(Real radian)
		{
			return radian / (Pi / 180);
		}

		/**
		 * @brief src  dest ֐UNH[^jI쐬
		 * @param src ̕xNgiK͓ōsj
		 * @param dest ړI̕PʃxNgiK͓ōsj
		 * @remarks
		 *     ̏ꍇA fallbackAxis ͎IɌvZB
		 *     ڂ̓I[o[[h`
		 */
		static Quaternion CreateQuaternionRotationTo(const Vector3 &src, const Vector3 &dest);

		/**
		 * @brief src  dest ֐UNH[^jI쐬
		 * @param src ̕xNgiK͓ōsj
		 * @param dest ړI̕PʃxNgiK͓ōsj
		 * @param fallbackAxis srcdestقڋtxNgꍇɎgp]
		 */
		static Quaternion CreateQuaternionRotationTo(const Vector3 &src, const Vector3 &dest,
			const Vector3& fallbackAxis);
	};
}

#endif