#ifndef __BuddhaModel_H__
#define __BuddhaModel_H__

#include "BuddhaLibPrerequisites.h"
#include "BuddhaEffect.h"
#include "BuddhaVector4.h"
#include "BuddhaTexture2D.h"
#include "BuddhaSharedPtr.h"

#include <d3dx9.h>
#include <list>
#include <vector>

namespace BuddhaLib
{
	class GraphicsDevice;
	class ModelMesh;
	class Texture2D;
	class IndexBuffer;
	class VertexBuffer;
	class ModelMeshPart;
	class VertexDeclaration;
	class ModelMesh;
	class ModelPtr;
	class ModelBone;

	///  ModelMesh IuWFNgō\ꂽ3Df
	class Model
	{
		friend ModelMesh;

	public:
		/// ModelMesh ̃RNV
		typedef std::vector<ModelMesh*> ModelMeshList;

		/// ModelBone ̃RNV
		typedef std::vector<ModelBone*> ModelBoneList;

	protected:
		Model(GraphicsDevice *device);

		// LPD3DXMESH m_pMesh;

		GraphicsDevice* m_pDevice;

		ModelMeshList mModelMeshList;

		ModelBoneList mModelBoneList;

	public:
		virtual ~Model();

		/// ̃fi[郂fbV̐擾
		int GetNumModelMeshes(void) const;

		/**
		 * @brief w肵CfbNXԍ̃fbV擾
		 * @exception ArgumentOutOfRangeException w肵CfbNXfbVi[z͈̔͂𒴂Ă
		 */
		ModelMesh* GetModelMesh(int idx) const;

		/**
		 * @brief ̃fi[{[̐擾
		 * @return {[̐
		 */
		unsigned int GetNumModelBones(void) const;

		/**
		 * @brief w肵ItZbgCfbNXԍ ModelBone 擾
		 * @param idx CfbNXԍ
		 * @return ModelBone IuWFNgւ̃|C^BȃCfbNXw肵ꍇA NULL ߂
		 * @exception ArgumentOutOfRangeException w肵CfbNX{[i[z͈̔͂𒴂Ă
		 */
		ModelBone* GetModelBone(unsigned int idx) const;

		/**
		 * @internal
		 */
		static ModelPtr _fromFile(GraphicsDevice* device, LPCWSTR filePath);

		/**
		 * @brief filePath  .X t@CǂݍŃf\z
		 * @note
		 *     GtFNgɂ HardwareEffect gp
		 */
		static ModelPtr FromFile(GraphicsDevice* device, LPCWSTR filePath);

		/// filePath  .X t@Cǂݍ݁Aw肵GtFNg蓖Ăăf\z
		static ModelPtr FromFile(GraphicsDevice* device, LPCWSTR filePath, EffectPtr effect);
	};

	/// Model NXp̋L|C^NX
	class ModelPtr : public SharedPtr<Model>
	{
	public:
		ModelPtr() : SharedPtr<Model>() {}
		explicit ModelPtr(Model* rep) : SharedPtr<Model>(rep) {}
		ModelPtr(const ModelPtr &r) : SharedPtr<Model>(r) {}
	protected:
		void destory(void)
		{
			SharedPtr<Model>::destroy();
		}
	};
}

#endif