#ifndef __BuddhaQuaternion_H__
#define __BuddhaQuaternion_H__

#include "BuddhaLibPrerequisites.h"
#include <d3d9.h>

namespace BuddhaLib
{
	struct Vector3;

	/// NH[^jI
	struct Quaternion
	{
	public:
		/// ]
		FLOAT W;

		/// xNgXl
		FLOAT X;

		/// xNgYl
		FLOAT Y;

		/// xNgZl
		FLOAT Z;

		Quaternion();

		Quaternion(FLOAT fX, FLOAT fY, FLOAT fZ, FLOAT fW);

		//------------------------------------------------------------------------
		static const Quaternion Zero;

		/// ]Ԃ̃NH[^jI
		static const Quaternion Identity;
		//------------------------------------------------------------------------
		/// w莲ɑ΂Ďwpx̎pNH[^jI쐬ĕԂ
		static Quaternion CreateFromAxisAngle(const Vector3 &axis, const FLOAT angle);

		/// w莲ɑ΂Ďwpx̎pNH[^jI쐬
		static void CreateFromAxisAngle(const Vector3 &axis, const FLOAT angle, Quaternion &out);

		/// tNH[^jIԂ
		static Quaternion Inverse(const Quaternion &q);
		//------------------------------------------------------------------------
		inline Quaternion operator *= (const Quaternion &value)
		{
			X = Y * value.Z - Z * value.Y + W * value.X + X * value.W;
			Y =	Z * value.X - X * value.Z + W * value.Y + Y * value.W;
			Z = X * value.Y - Y * value.X + W * value.Z + Z * value.W;
			W = W * value.W - X * value.X - Y * value.Y - Z * value.Z;

			return *this;
		}
		//------------------------------------------------------------------------
		inline friend Quaternion operator * (const Quaternion &left, const Quaternion &right)
		{
			return Quaternion (
				left.Y * right.Z - left.Z * right.Y + left.W * right.X + left.X * right.W,
				left.Z * right.X - left.X * right.Z + left.W * right.Y + left.Y * right.W,
				left.X * right.Y - left.Y * right.X + left.W * right.Z + left.Z * right.W,
				left.W * right.W - left.X * right.X - left.Y * right.Y - left.Z * right.Z
			);
		}
		//------------------------------------------------------------------------
		void Normalize(void);
	};
}

#endif