#ifndef __BuddhaRenderTarget2D_H__
#define __BuddhaRenderTarget2D_H__

#include "BuddhaLibPrerequisites.h"
#include "BuddhaSurfaceFormat.h"
#include "BuddhaSharedPtr.h"

namespace BuddhaLib
{
	class GraphicsDevice;
	class Texture2D;

	/// _[^[Qbg
	class RenderTarget2D
	{
	public:
		RenderTarget2D(GraphicsDevice* device, int width, int height, int numberLevels, D3DFORMAT format);
		virtual ~RenderTarget2D();

		/** DirectX9 ^̃T[tFCXւ̃|C^Ԃ܂B
		 * @remarks
		 *     bsO֌WAPIDX9̎YɒڃANZX邽߂Ɏg܂B
		 */
		LPDIRECT3DSURFACE9 _getD3D9Surface(void);

		Texture2D* GetTexture(void);

	protected:
		/// DirectX eNX`ւ̃|C^
		LPDIRECT3DTEXTURE9 m_pTexture;

		/// T[tFCXւ̃|C^
		LPDIRECT3DSURFACE9 m_pSurface;

		/// 
		int mWidth;

		/// c
		int mHeight;
	};

	/// RenderTarget2D NXp̔틤L|C^NX
	class RenderTarget2DPtr : SharedPtr<RenderTarget2D>
	{
	public:
		RenderTarget2DPtr() : SharedPtr<RenderTarget2D>() {}
		explicit RenderTarget2DPtr(RenderTarget2D* rep) : SharedPtr<RenderTarget2D>(rep) {}
		RenderTarget2DPtr(const RenderTarget2DPtr &r) : SharedPtr<RenderTarget2D>(r) {}
	protected:
		void destory(void)
		{
			SharedPtr<RenderTarget2D>::destroy();
		}
	};
}

#endif