#ifndef __BuddhaTexture2D_H__
#define __BuddhaTexture2D_H__

#include "BuddhaLibPrerequisites.h"

#include <d3dx9.h>
#include "BuddhaRectangle.h"
#include "BuddhaSharedPtr.h"

namespace BuddhaLib
{
	class GraphicsDevice;
	class RenderTarget2D;
	class Texture2DPtr;

	/**
	 * @brief QeNX` - eNẐQObh\
	 */
	class Texture2D
	{
	protected:
		LPDIRECT3DTEXTURE9 m_pTexture;
		Rectangle mRectangle;
		RECT mRect;

		friend RenderTarget2D;

	public:
		Texture2D();

		/**
		 * @brief 񏉊eNX`쐬RXgN^
		 * 
		 * ^ꂽ傫A\[XprAtH[}bgAĂȂ Texture2D \[X쐬܂B
		 * t@C̃[h Texture2D 邽߂ɂ Texture2D::FromFile() QƂĂB
		 */
		Texture2D(GraphicsDevice* device, int width, int height, int numberLevels, DWORD usage, D3DFORMAT format);

		virtual ~Texture2D();

		/// 擾
		inline int GetWidth(void) const
		{
			return mRectangle.Width;
		}

		/// 擾
		inline int GetHeight(void) const
		{
			return mRectangle.Height;
		}

		/**
		 * @brief }`xeNX`̃eNX`x̐擾
		 */
		inline int GetLevelCount(void)
		{
			return m_pTexture->GetLevelCount();
		}

		/**
		 * @brief eNX`ɐݒ肳Ăőڍ׃x (LOD) 擾
		 */
		inline int GetLevelOfDetail(void)
		{
			return m_pTexture->GetLOD();
		}

		static void FromFile(GraphicsDevice* device, LPCWSTR filePath, Texture2D** pOut);

		/**
		 * @brief \a filePath ̃eNX`t@C[h
		 * @exception FileNotFoundException w肳ꂽt@CȂ
		 */
		static Texture2DPtr FromFile(GraphicsDevice* device, LPCWSTR filePath);

		/**
		 * @brief \a filePath ̃eNX`t@C[h
		 * @exception FileNotFoundException w肳ꂽt@CȂ
		 */
		static Texture2DPtr FromFile(GraphicsDevice* device, const String &filePath);

		/// 11̃_~[eNX`쐬܂
		static Texture2D* CreateDummy(GraphicsDevice* device);

		LPDIRECT3DTEXTURE9 _getD3D9Texture() const
		{
			return m_pTexture;
		}

		void _setRectangle(Rectangle rect)
		{
			mRectangle = rect;

			mRect.left = mRectangle.X;
			mRect.right = mRectangle.X + mRectangle.Width;
			mRect.top = mRectangle.Y;
			mRect.bottom = mRectangle.Y + mRectangle.Height;
		}

		Rectangle GetRectangle(void) const
		{
			return mRectangle;
		}

		RECT GetRect(void) const
		{
			return mRect;
		}
	};

	class Texture2DPtr : public SharedPtr<Texture2D>
	{
	public:
		Texture2DPtr() : SharedPtr<Texture2D>() {}
		explicit Texture2DPtr(Texture2D* rep) : SharedPtr<Texture2D>(rep) {}
		Texture2DPtr(const Texture2DPtr &r) : SharedPtr<Texture2D>(r) {}
	protected:
		void destory(void)
		{
			SharedPtr<Texture2D>::destroy();
		}
	};
}


#endif